#include <xc.h>
#include "hd44780.h"
#include "config.h"


void LCDinit(){
	//SOFTWARE RESET
	__delay_ms(50);
	LCD_RS=0;

        #if defined(LCD_PORT_LOWER_NIBLE)
        LCD_PORT=0x03;
        #else
        LCD_PORT=0x30;
        #endif

        LCDclk();
	__delay_ms(5);
        #if defined(LCD_PORT_LOWER_NIBLE)
        LCD_PORT=0x03;
        #else
        LCD_PORT=0x30;
        #endif
        LCDclk();
	__delay_us(200);
	#if defined(LCD_PORT_LOWER_NIBLE)
        LCD_PORT=0x03;
        #else
        LCD_PORT=0x30;
        #endif
        LCDclk();
	//INIT 
	#if defined(LCD_PORT_LOWER_NIBLE)
        LCD_PORT=0x02;
        #else
        LCD_PORT=0x20;
        #endif
        LCDclk();
	LCDwrite(LCD_COMMAND,0x2C);// > 1 line, 4 bit
	LCDwrite(LCD_COMMAND,0x0F);//LCD on, CURSOR on, CURSOR BLINKING on
	LCDwrite(LCD_COMMAND,0x14);//move cursor right, no shifting
	LCDclear();
}	

void LCDwrite(char type, char c){
#if defined(LCD_PORT_LOWER_NIBLE)

	LCD_PORT=c>>4;
	LCD_RS=type;	LCDclk();
	LCD_PORT=c&0x0f;
	LCD_RS=type;	LCDclk();

#else
	LCD_PORT=c&0xf0;
	LCD_RS=type;	LCDclk();
	LCD_PORT=c<<4;
	LCD_RS=type;	LCDclk();
#endif
}

void LCDprint(char p[]){
	while(*p){
		LCDwrite(LCD_DATA,*p);
		p++;
	}
}	

void LCDpos(char x, char y){
	char position = y ;
	if((x & 0x01) == 0x01) position+=0x40;
	if((x & 0x02) == 0x02) position+=LCD_WIDTH;
	LCDwrite(LCD_COMMAND,0x80 + position);
}	

void LCDclear(){
	LCDwrite(LCD_COMMAND,0x01);
	__delay_ms(2);
}

void LCDvalue8(char v){
	LCDwrite(LCD_COMMAND,0x04);					//now cursor move left
	
	LCDwrite(LCD_DATA,0x30+v%10);
	v/=10;
	if(v!=0){
		LCDwrite(LCD_DATA,0x30+v%10);
		v/=10;
		if(v!=0){
			LCDwrite(LCD_DATA,0x30+v);
		}
	}
	
	LCDwrite(LCD_COMMAND,6);					//restore normal cursor behavior
}

void LCDvalue16(unsigned int v){
	LCDwrite(LCD_COMMAND,0x04);					//now cursor move left

	LCDwrite(LCD_DATA,0x30+v%10);
	v/=10;
	if(v!=0){
		LCDwrite(LCD_DATA,0x30+v%10);
		v/=10;
		if(v!=0){
                        LCDwrite(LCD_DATA,0x30+v%10);
                        v/=10;
                        if(v!=0){
                            LCDwrite(LCD_DATA,0x30+v%10);
                            v/=10;
                            if(v!=0){
                                LCDwrite(LCD_DATA,0x30+v%10);
                                v/=10;
                                if(v!=0){
                                    LCDwrite(LCD_DATA,0x30+v);
                                }
                            }
                        }
		}
	}

	LCDwrite(LCD_COMMAND,6);					//restore normal cursor behavior
}

void LCDcustomCar(char carnumber, char * car){
	LCDwrite(LCD_COMMAND,0x40+carnumber&0b00001111);
	for(char i=0;i<8;i++){
		LCDwrite(LCD_DATA,car[i]);
	}
}		